/*
*	play .Wav files function
*
*/

/* Includes ------------------------------------------------------------------*/
#include    "adpcm.h"
#include    "playWav.h"

/* Private define ------------------------------------------------------------*/
#define F_STOP  0x00        //
#define F_PLAY  0x01
#define F_PAUSE 0x02
#define F_BUFF  0x10        //ǰbuff number,ʵping-pang
#define F_LAST  0x20        //Ϊһbuff,ϾֹͣڶbuffʱЧ
#define F_BOUND 0x80        //Ҫлbuff
#define F_MASK  0xFF

#define C_BLOCK_SIZE    256
#define C_BUFF_MIDDLE   (C_BLOCK_SIZE<<1)
#define C_BUFF_SIZE     (C_BLOCK_SIZE<<2)

#define C_MUTE_DATA     0x00
/* Private variables ---------------------------------------------------------*/
uint8_t myBuff[C_BUFF_SIZE];       //һadpcmblock144*blockС16bitתΪ8bit2*blockС˫*2.
st_WaveHeader adpcm_header;
uint8_t playFlag = 0;
uint16_t bufIndex = 0;
uint8_t *p_buf = myBuff;
uint32_t pw_blockCount = 0;         //blockܸ
uint16_t pw_lastBlockDataCount = 0; //һblockݴС
uint32_t pw_blockCur = 0;   //һҪصblock       
const uint8_t *p_dataHeader;      //adpcmݵͷָ
uint16_t pw_buff1Samples = 0;   //buff1
uint16_t pw_buff2Samples = 0;   //buff2
/* Private user code ---------------------------------------------------------*/

/* Private macro -------------------------------------------------------------*/
#define getPF(xbit)		(playFlag&xbit)
#define setPF(xbit)		(playFlag|=xbit)
#define clrPF(xbit)		(playFlag&=(~xbit))
/* Public function prototypes -----------------------------------------------*/

//void playWav_init(void);	//ʼ

//uint8_t playWav(const unsigned char *pcm_data);	//ROMеݣΪROMеͷָ.

//void playWav_reload(void);	//زݣڲже

//void playWav_loop(void);		//ѭȡݣѭеҪʱҪСһbufferĲʱ.

/* Private function prototypes ---------------------------------------------*/
static void pw_ConfigPWMChannel(void);
static void pw_ConfigTIM1Base(void);
static void pw_ConfigTIM3Base(void);


/**
  * @brief  playWav_initӦóʼ.
  * @retval NULL
  */
void playWav_init(void)
{
  
    /* ʹTIM1GPIOʱ */
    LL_APB1_GRP2_EnableClock(LL_APB1_GRP2_PERIPH_TIM1);
    LL_APB1_GRP1_EnableClock(LL_APB1_GRP1_PERIPH_TIM3);	
    LL_IOP_GRP1_EnableClock(LL_IOP_GRP1_PERIPH_GPIOA);
	
    /* ò״̬ */
    clrPF(F_MASK);
    
    /* TIM1 PWMͨ */
    pw_ConfigPWMChannel();
  
    /* òTIM1 PWMģʽ pwmƵ*/
    pw_ConfigTIM1Base();
	
    /* òTIM3 ʱģʽ */	
    pw_ConfigTIM3Base();
	          
	__NOP();
	
}

/**
  * @brief  pw_loadRom2Buff()Ӧú.
* @ par: ԴѹݵַĿbufferַѹݴСpdstpsrcҪӦѹ
  * @retval NULL
  */
void pw_loadRom2Buff(const uint8_t *psrc, uint8_t *pdst, const uint16_t size)
{

    adpcm_decode_block_to8Bits(pdst, (uint8_t *)psrc,size);

}


/**
  * @brief  playWav()Ӧóʼ.
  * @retval 0=ok; other=error code
  */

uint8_t playWav(const unsigned char *pcm_data)
{
	static uint32_t temp;

    /* ʼļͷϢ */
	temp = adpcm_init(pcm_data,0x60,&adpcm_header);
    
    /* ļǷϹ */
    if(temp != 0x3C)    return 1;
    if(adpcm_header.fmt.AudioFormat != 0x11) return 2;
    if(adpcm_header.fmt.SampleRate != 0x1F40) return 3;
    if(adpcm_header.fmt.NumOfChannels != 0x01) return 4;    
    if(adpcm_header.fmt.BlockAlign != C_BLOCK_SIZE) return 5; 
    p_dataHeader = pcm_data + temp; //ʼַ
    /* ֹͣ */
    clrPF(F_MASK);
    
    /* ȡؼݵı */
    pw_blockCount = adpcm_header.data.ChunkSize / adpcm_header.fmt.BlockAlign;        //
    pw_lastBlockDataCount =  adpcm_header.data.ChunkSize % adpcm_header.fmt.BlockAlign;     //һݸ
    if(pw_lastBlockDataCount>=4) pw_lastBlockDataCount+=1;  //һ飬blockͷϢ4bytes
    pw_buff1Samples = adpcm_header.fmt.sampleperblock;
    pw_buff2Samples = pw_buff1Samples;

    pw_blockCur = 0;    //ӵ0鿪ʼ
    pw_loadRom2Buff(p_dataHeader, myBuff, pw_buff1Samples);   //buffer1
    pw_blockCur = 1;
    pw_loadRom2Buff(p_dataHeader+C_BLOCK_SIZE, myBuff+C_BUFF_MIDDLE, pw_buff2Samples);   //buffer2 
    
    p_buf = myBuff;     //buff[]׵ַ
	bufIndex = 0;       //buff[]ǰŲֵ±
    
    clrPF(F_MASK);
    setPF(F_PLAY);      //ʼ  
    
    return 0;
}

/**
  * @brief  playWav_stop()Ӧú.
  * @retval NULL
  */
void playWav_stop(void)
{
    clrPF(F_MASK);     
    LL_TIM_OC_SetCompareCH1(TIM1,C_MUTE_DATA);    //ؾֵ 
}

/**
  * @brief  playWav_reload()Ӧú.
  * @retval NULL
  */
void playWav_reload(void)
{
	if(getPF(F_PLAY))
	{
		LL_TIM_OC_SetCompareCH1(TIM1,*(p_buf+bufIndex));    //زֵ
        bufIndex++;
        //if(bufIndex==(C_BUFF_MIDDLE+pw_buff2Samples)) bufIndex = 0;
        //buff1
        if(bufIndex==pw_buff1Samples) {
            if(getPF(F_LAST)) {
                playWav_stop();
            }            
			setPF(F_BUFF);      //buffer1
			setPF(F_BOUND);
            bufIndex = C_BUFF_MIDDLE;   //            
        } else if(bufIndex==(C_BUFF_MIDDLE+pw_buff2Samples)) {
            if(getPF(F_LAST)) {
                playWav_stop();
            }
			clrPF(F_BUFF);      //buffer2
			setPF(F_BOUND);
            bufIndex = 0;
		}
	}
}

/**
  * @brief  playWav_loop()Ӧú.
  * @retval NULL
  */
void playWav_loop(void)
{

    if( getPF(F_PLAY)) {
		//ƹ
		if(getPF(F_BOUND))
		{
			if(getPF(F_BUFF))
			{
				//Buff1
                if(pw_blockCur<(pw_blockCount-1)) {
                    pw_buff1Samples = adpcm_header.fmt.sampleperblock;
                    pw_loadRom2Buff(p_dataHeader+pw_blockCur*C_BLOCK_SIZE, myBuff, pw_buff1Samples);  
                    pw_blockCur++;
                } else {
                    pw_buff1Samples = (pw_lastBlockDataCount-4)*2+1;
                    pw_loadRom2Buff(p_dataHeader+(pw_blockCount-1)*C_BLOCK_SIZE, myBuff, pw_buff1Samples);                     
                    setPF(F_LAST);      //ݼ,ᶪʧһblockҪ
                }				                
				clrPF(F_BOUND);
			}else{
				//Buff2
                if(pw_blockCur<(pw_blockCount-1)) {
                    pw_buff2Samples = adpcm_header.fmt.sampleperblock;
                    pw_loadRom2Buff(p_dataHeader+pw_blockCur*C_BLOCK_SIZE, myBuff+C_BUFF_MIDDLE, pw_buff2Samples);  
                    pw_blockCur++;
                } else {
                    pw_buff2Samples = (pw_lastBlockDataCount-4)*2+1;
                    pw_loadRom2Buff(p_dataHeader+(pw_blockCount-1)*C_BLOCK_SIZE, myBuff+C_BUFF_MIDDLE, pw_buff2Samples);                     
                    setPF(F_LAST);      //ݼ,ᶪʧһblockҪ
                }				                
				clrPF(F_BOUND);
			}
		}



    }        
    
}


/**
  * @brief  TIM1 PWMGPIO
  * @param  
  * @retval 
  */
#define CFG_ENABLE_OCN
static void pw_ConfigPWMChannel(void)
{
  LL_GPIO_InitTypeDef TIM1CH1MapInit= {0};
  LL_TIM_OC_InitTypeDef TIM_OC_Initstruct ={0};

  /* PA0ΪTIM1_CH1N */
  TIM1CH1MapInit.Pin        = LL_GPIO_PIN_0;
  TIM1CH1MapInit.Mode       = LL_GPIO_MODE_ALTERNATE;
  TIM1CH1MapInit.Alternate  = LL_GPIO_AF_14; 
  LL_GPIO_Init(GPIOA,&TIM1CH1MapInit);
  
  /* PA3ΪTIM1_CH1 */
  TIM1CH1MapInit.Pin        = LL_GPIO_PIN_3;
  TIM1CH1MapInit.Mode       = LL_GPIO_MODE_ALTERNATE;
  TIM1CH1MapInit.Alternate  = LL_GPIO_AF_13; 
  LL_GPIO_Init(GPIOA,&TIM1CH1MapInit);
  
  /* PWMͨ */
  TIM_OC_Initstruct.OCMode        = LL_TIM_OCMODE_PWM1;     /* ͨģʽPWM1 */
  TIM_OC_Initstruct.OCState       = LL_TIM_OCSTATE_ENABLE;  /* ͨ״̬ */
  TIM_OC_Initstruct.OCNState      = LL_TIM_OCSTATE_ENABLE;  /* ͨ״̬ */
  TIM_OC_Initstruct.OCPolarity    = LL_TIM_OCPOLARITY_HIGH; /* ͨЧԣߵƽ */
  TIM_OC_Initstruct.OCNPolarity   = LL_TIM_OCPOLARITY_HIGH; /* ͨЧԣߵƽ */
  TIM_OC_Initstruct.OCIdleState   = LL_TIM_OCIDLESTATE_LOW; /* ͨмԣ͵ƽ */
  TIM_OC_Initstruct.OCNIdleState  = LL_TIM_OCIDLESTATE_LOW; /* ͨмԣ͵ƽ */
  /* ͨ1Ƚֵ:500 */
  TIM_OC_Initstruct.CompareValue  = 0;
  /* ͨ1 */
  LL_TIM_OC_Init(TIM1,LL_TIM_CHANNEL_CH1,&TIM_OC_Initstruct);
}

/**
  * @brief  TIM base
  * @param  
  * @retval 
  */
static void pw_ConfigTIM1Base(void)
{
  /* TIM1 */
  LL_TIM_InitTypeDef TIM1CountInit = {0};
 
  TIM1CountInit.ClockDivision       = LL_TIM_CLOCKDIVISION_DIV1; /* ʱӲƵ */
  TIM1CountInit.CounterMode         = LL_TIM_COUNTERMODE_UP;     /* ϼģʽ */
  TIM1CountInit.Prescaler           = 0;                    /* ԤƵֵ2400 */
  TIM1CountInit.Autoreload          = 256-1;                    /* Զװֵ1000 */
  TIM1CountInit.RepetitionCounter   = 0;                         /* ظֵ0 */
  
  /* ʼTIM1 */
  LL_TIM_Init(TIM1,&TIM1CountInit);
  
  /* ʹ */
  LL_TIM_EnableAllOutputs(TIM1);

  /* ʹTIM1 */
  LL_TIM_EnableCounter(TIM1);
}

/**
* @brief  TIM3 Ϊ8KHz
  * @param  
  * @retval 
  */
static void pw_ConfigTIM3Base(void)
{
  /* ԤƵֵ8000 */
  LL_TIM_SetPrescaler(TIM3,24-1);
  
  /* ģʽϼ */
  LL_TIM_SetCounterMode(TIM3,LL_TIM_COUNTERMODE_UP);
  
  /* װֵ1000-1 */
  LL_TIM_SetAutoReload(TIM3,125-2);
  
  /* ʱӲƵ */
  LL_TIM_SetClockDivision(TIM3,LL_TIM_CLOCKDIVISION_DIV1);
  
  /* Ϊ¼ */
  LL_TIM_EnableIT_UPDATE(TIM3);
	
   /*USART1жȼ*/
   NVIC_SetPriority(TIM3_IRQn,0);
   /*ʹUSART1ж*/
   NVIC_EnableIRQ(TIM3_IRQn);	
  
  /* ʹTIM3 */
  LL_TIM_EnableCounter(TIM3);
}


